## jolicloud-hardware-repo 1.2.6

=== src/nvidia-current-260.19.29/Makefile ===
# This Makefile is automatically generated; do not edit
# Generated on 'swio-display-x86-rhel47-08.nvidia.com' on Wed Dec 8 12:09:19 PST 2010

# to use this file, rename or delete the default Makefile, then rename or
# link this file to Makefile. then type 'make'

#
# KBUILD Makefile for the NVIDIA Linux kernel module.
#
# The motivation for replacing the original Makefile is the hope that this
# version will simplify the build and installation process. In the past,
# many architectural and cosmetic changes to the Linux kernel have made it
# difficult to maintain compatibility or required duplication of logic.
#
# Linux 2.6 introduces numerous such changes, many of which impact modules.
# Relying on KBUILD, some aspects of the build system otherwise difficult
# to support (for example, module versioning) are abstracted away and dealt
# with elsewhere, making life significantly easier here.
#
# The new approach currently has its own share of problems, some of which
# are architectural difficulties with KBUILD, others minor annoyances. For
# this reason, an improved version of the NVIDIA Makefile is available to
# those experiencing difficulties.
#
# kbuild Makefile originally developed by:
#
# Alistair J Strachan (alistair@devzero.co.uk) (first pass, enhancements)
# Christian Zander (zander@mail.minion.de) (enhancements)
#

all: install
install: package-install

#
# The NVIDIA kernel module base name and static file names. KBUILD will go
# ahead and append ".o" or ".ko" to form the final module name.
#

MODULE_NAME := nvidia
VERSION_HEADER := nv_compiler.h

#
# List of object files to link into NVIDIA kernel module; make sure KBUILD
# understands that we want a module.
#

CORE_OBJS := nv-kernel.o
RESMAN_GLUE_OBJS := nv.o nv_gvi.o nv-vm.o os-agp.o os-interface.o os-registry.o nv-i2c.o nvacpi.o

$(MODULE_NAME)-objs := $(CORE_OBJS) $(RESMAN_GLUE_OBJS)

#
# The precompiled kernel module build process requires a separation of the
# closed source and open source object files.
#

KERNEL_GLUE_NAME := nv-linux.o
KERNEL_GLUE_OBJS := $(RESMAN_GLUE_OBJS) $(MODULE_NAME).mod.o

obj-m := $(MODULE_NAME).o

#
# Include local source directory in $(CC)'s include path and set disable any
# warning types that are of little interest to us.
#

EXTRA_CFLAGS += -I$(src)
EXTRA_CFLAGS += -Wall -MD $(DEFINES) $(INCLUDES) -Wsign-compare -Wno-cast-qual -Wno-error

#
# We rely on these two definitions below; if they aren't set, we set them to
# reasonable defaults (e.g. for top-level passes).
#

src ?= .
obj ?= .

#
# Determine location of the Linux kernel source tree. Allow users to override
# the default (i.e. automatically determined) kernel source location with the
# SYSSRC directive; this new directive replaces NVIDIA's SYSINCLUDE.
#

KERNEL_MODLIB := /lib/modules/$(shell uname -r)

ifdef SYSSRC
 KERNEL_SOURCES := $(SYSSRC)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
else
 KERNEL_UNAME := $(shell uname -r)
 KERNEL_SOURCES := $(shell test -d $(KERNEL_MODLIB)/source && echo $(KERNEL_MODLIB)/source || echo $(KERNEL_MODLIB)/build)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
endif

KERNEL_OUTPUT := $(KERNEL_SOURCES)
KBUILD_PARAMS :=

ifdef SYSOUT
 ifneq ($(SYSOUT), $(KERNEL_SOURCES))
 KERNEL_OUTPUT := $(SYSOUT)
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
else
 ifeq ($(KERNEL_SOURCES), $(KERNEL_MODLIB)/source)
 KERNEL_OUTPUT := $(KERNEL_MODLIB)/build
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
endif

CC ?= cc
HOST_CC ?= $(CC)
LD ?= ld

ifndef ARCH
 ARCH := $(shell uname -m | sed -e 's/i.86/i386/')
endif

CONFTEST := /bin/sh $(src)/conftest.sh "$(CC)" "$(HOST_CC)" $(ARCH) $(KERNEL_SOURCES) $(KERNEL_OUTPUT)

KERNEL_UNAME ?= $(shell $(CONFTEST) get_uname)
MODULE_ROOT := /lib/modules/$(KERNEL_UNAME)/kernel/drivers

#
# Sets any internal variables left unset by KBUILD (e.g. this happens during
# a top-level run).
#

TOPDIR ?= $(KERNEL_SOURCES)

#
# Linux 2.6 uses the .ko module extension.
#

MODULE_OBJECT := $(MODULE_NAME).ko

#
# NVIDIA specific CFLAGS and #define's.
#

EXTRA_CFLAGS += -D__KERNEL__ -DMODULE -DNVRM -DNV_VERSION_STRING=\"260.19.29\" -UDEBUG -U_DEBUG -DNDEBUG


COMPILE_TESTS = \
	remap_page_range \
	remap_pfn_range \
	vmap \
	agp_backend_acquire \
	set_pages_uc \
	change_page_attr \
	i2c_adapter \
	pci_get_class \
	pm_message_t \
	irq_handler_t \
	pci_choose_state \
	vm_insert_page \
	acpi_device_ops \
	acpi_device_id \
	acquire_console_sem \
	kmem_cache_create \
	on_each_cpu \
	smp_call_function \
	vmm_support \
	acpi_evaluate_integer \
	ioremap_wc \
	proc_dir_entry \
	INIT_WORK \
	acpi_walk_namespace \
	agp_memory \
	scatterlist \
	pci_domain_nr \
	pci_dma_mapping_error \
	file_operations \
	sg_init_table

#
# Miscellaneous NVIDIA kernel module build support targets. They are needed
# to satisfy KBUILD requirements and to support NVIDIA specifics.
#

$(obj)/$(CORE_OBJS):
	@cp $(src)/$(CORE_OBJS) $(obj)/$(CORE_OBJS)

$(obj)/$(VERSION_HEADER):
	@echo \#define NV_COMPILER \"`$(CC) -v 2>&1 | tail -n 1`\" > $@

$(obj)/conftest.h: $(src)/conftest.sh
	@if ! $(CONFTEST) compile_tests $(COMPILE_TESTS); then exit 1; fi

$(obj)/patches.h:
	@if ! $(CONFTEST) patch_check; then exit 1; fi

RESMAN_GLUE_TARGETS = $(addprefix $(obj)/,$(RESMAN_GLUE_OBJS))

$(RESMAN_GLUE_TARGETS): $(obj)/conftest.h $(obj)/patches.h

$(obj)/nv.o: $(obj)/$(VERSION_HEADER)

#
# KBUILD build parameters.
#

ifndef NV_VERBOSE
 ifneq ($(strip $(QUIET)),1)
 NV_VERBOSE=1
 else
 NV_VERBOSE=0
 endif
endif

KBUILD_PARAMS += KBUILD_VERBOSE=$(NV_VERBOSE)
KBUILD_PARAMS += -C $(KERNEL_SOURCES) SUBDIRS=$(PWD)
KBUILD_PARAMS += ARCH=$(ARCH)

#
# NVIDIA sanity checks.
#

.PHONY: suser-sanity-check rmmod-sanity-check build-sanity-checks

suser-sanity-check:
	@if ! $(CONFTEST) suser_sanity_check; then exit 1; fi

rmmod-sanity-check:
	@if ! $(CONFTEST) rmmod_sanity_check; then exit 1; fi

build-sanity-checks:
	@if ! $(CONFTEST) cc_version_check 		full_output; then exit 1; fi
	@if ! $(CONFTEST) rivafb_sanity_check 	full_output; then exit 1; fi
	@if ! $(CONFTEST) nvidiafb_sanity_check full_output; then exit 1; fi
	@if ! $(CONFTEST) xen_sanity_check 		full_output; then exit 1; fi

#
# Build the NVIDIA kernel module using Linux KBUILD. This target is used by
# the "package-install" target below.
#

module: build-sanity-checks
	@echo "NVIDIA: calling KBUILD..."; \
	 $(MAKE) "CC=$(CC)" $(KBUILD_PARAMS) modules; \
	echo "NVIDIA: left KBUILD."; \
	if ! [ -f $(MODULE_OBJECT) ]; then \
	 echo "$(MODULE_OBJECT) failed to build!"; \
	 exit 1; \
	fi

#
# Build the NVIDIA kernel module with KBUILD. Verify that the user posesses
# sufficient privileges. Rebuild the module dependency file.
#

module-install: suser-sanity-check module
	@mkdir -p $(MODULE_ROOT)/video; \
	install -m 0664 -o root -g root $(MODULE_OBJECT) $(MODULE_ROOT)/video; \
	PATH="$(PATH):/bin:/sbin" depmod -ae;

#
# This target builds, then installs, then creates device nodes and inserts
# the module, if successful.
#

package-install: module-install rmmod-sanity-check
	@PATH="$(PATH):/bin:/sbin" modprobe $(MODULE_NAME) && \
	echo "$(MODULE_OBJECT) installed successfully.";

#
# Build an object file suitable for further processing by the installer
# and inclusion as a precompiled kernel interface file. Note the
# dependency on 'module', and not just the input object files. This is
# because we rely on KBUILD to produce the latter as part of the
# full kernel module build.
#

$(KERNEL_GLUE_NAME): module
	@$(LD) $(EXTRA_LDFLAGS) -r -o $(KERNEL_GLUE_NAME) $(KERNEL_GLUE_OBJS)

#
# Support hack, KBUILD isn't prepared to clean up after external modules.
#

clean:
	@$(RM) -f $(RESMAN_GLUE_OBJS) $(KERNEL_GLUE_OBJS)
	@$(RM) -f build-in.o nv-linux.o *.d .*.{cmd,flags}
	@$(RM) -f $(MODULE_NAME).{o,ko,mod.{o,c}} $(VERSION_HEADER) *~
	@$(RM) -f patches.h
	@$(RM) -f conftest*.c conftest.h
	@$(RM) -rf Modules.symvers .tmp_versions

#
# This target just prints the kernel module filename (for use by the
# installer)
#

print-module-filename:
	@echo $(MODULE_OBJECT)

=== src/nvidia-legacy-173-173.14.28/Makefile ===
# This Makefile is automatically generated; do not edit
# Generated on 'builder63' on Wed Sep 29 09:47:27 PDT 2010

# to use this file, rename or delete the default Makefile, then rename or
# link this file to Makefile. then type 'make'

#
# KBUILD Makefile for the NVIDIA Linux kernel module.
#
# The motivation for replacing the original Makefile is the hope that this
# version will simplify the build and installation process. In the past,
# many architectural and cosmetic changes to the Linux kernel have made it
# difficult to maintain compatibility or required duplication of logic.
#
# Linux 2.6 introduces numerous such changes, many of which impact modules.
# Relying on KBUILD, some aspects of the build system otherwise difficult
# to support (for example, module versioning) are abstracted away and dealt
# with elsewhere, making life significantly easier here.
#
# The new approach currently has its own share of problems, some of which
# are architectural difficulties with KBUILD, others minor annoyances. For
# this reason, an improved version of the NVIDIA Makefile is available to
# those experiencing difficulties.
#
# kbuild Makefile originally developed by:
#
# Alistair J Strachan (alistair@devzero.co.uk) (first pass, enhancements)
# Christian Zander (zander@mail.minion.de) (enhancements)
#

all: install
install: package-install

#
# The NVIDIA kernel module base name and static file names. KBUILD will go
# ahead and append ".o" or ".ko" to form the final module name.
#

MODULE_NAME := nvidia
VERSION_HEADER := nv_compiler.h

#
# List of object files to link into NVIDIA kernel module; make sure KBUILD
# understands that we want a module.
#

CORE_OBJS := nv-kernel.o
RESMAN_GLUE_OBJS := nv.o nv-vm.o os-agp.o os-interface.o os-registry.o nv-i2c.o nvacpi.o

$(MODULE_NAME)-objs := $(CORE_OBJS) $(RESMAN_GLUE_OBJS)

#
# The precompiled kernel module build process requires a separation of the
# closed source and open source object files.
#

KERNEL_GLUE_NAME := nv-linux.o
KERNEL_GLUE_OBJS := $(RESMAN_GLUE_OBJS) $(MODULE_NAME).mod.o

#
# A bug in KBUILD 2.4 means that leaving obj-m set in top-level context
# will cause Rules.make to call pathdown.sh, which is wrong. So, we only
# set this conditional of a kernel-level instance.
#

TOPDIR ?= $(srctree)

ifdef TOPDIR
obj-m := $(MODULE_NAME).o
endif

#
# Include local source directory in $(CC)'s include path and set disable any
# warning types that are of little interest to us.
#

EXTRA_CFLAGS += -I$(src)
EXTRA_CFLAGS += -Wall -Wimplicit -Wreturn-type -Wswitch -Wformat -Wchar-subscripts -Wparentheses -Wpointer-arith -Wno-multichar -Werror -MD $(DEFINES) $(INCLUDES) -Wsign-compare -Wno-cast-qual -Wno-error

#
# We rely on these two definitions below; if they aren't set, we set them to
# reasonable defaults (Linux 2.4's KBUILD, and top-level passes will not set
# these).
#

src ?= .
obj ?= .

#
# Determine location of the Linux kernel source tree. Allow users to override
# the default (i.e. automatically determined) kernel source location with the
# SYSSRC directive; this new directive replaces NVIDIA's SYSINCLUDE.
#

KERNEL_MODLIB := /lib/modules/$(shell uname -r)

ifdef SYSSRC
 KERNEL_SOURCES := $(SYSSRC)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
else
 KERNEL_UNAME := $(shell uname -r)
 KERNEL_SOURCES := $(shell test -d $(KERNEL_MODLIB)/source && echo $(KERNEL_MODLIB)/source || echo $(KERNEL_MODLIB)/build)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
endif

KERNEL_OUTPUT := $(KERNEL_SOURCES)
KBUILD_PARAMS :=

ifdef SYSOUT
 ifneq ($(SYSOUT), $(KERNEL_SOURCES))
 KERNEL_OUTPUT := $(SYSOUT)
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
else
 ifeq ($(KERNEL_SOURCES), $(KERNEL_MODLIB)/source)
 KERNEL_OUTPUT := $(KERNEL_MODLIB)/build
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
endif

CC ?= cc
HOST_CC ?= $(CC)
OBJDUMP ?= objdump
CONFTEST := /bin/sh $(src)/conftest.sh "$(CC)" "$(HOST_CC)" $(KERNEL_SOURCES) $(KERNEL_OUTPUT)

KERNEL_UNAME ?= $(shell $(CONFTEST) get_uname)
MODULE_ROOT := /lib/modules/$(KERNEL_UNAME)/kernel/drivers

#
# Sets any internal variables left unset by KBUILD (e.g. this happens during
# a top-level run).
#

TOPDIR ?= $(KERNEL_SOURCES)
PATCHLEVEL ?= $(shell $(CONFTEST) kernel_patch_level)

#
# Linux 2.4 uses the .o module extension. Linux 2.6, however, uses the .ko
# module extension. Handle these gracefully.
#

ifeq ($(PATCHLEVEL), 4)
 MODULE_OBJECT := $(MODULE_NAME).o
else
 MODULE_OBJECT := $(MODULE_NAME).ko
endif

#
# NVIDIA specific CFLAGS and #define's. The remap_page_range check has become
# necessary with the introduction of the five argument version to Linux 2.4
# distribution kernels; this conflicting change cannot be detected at compile
# time.
#

EXTRA_CFLAGS += -D__KERNEL__ -DMODULE -DNVRM -DNV_VERSION_STRING=\"173.14.28\" -UDEBUG -U_DEBUG -DNDEBUG

ifeq ($(shell echo $(NVDEBUG)),1)
 ifeq ($(shell test -z $(RMDEBUG) && echo yes),yes)
 RMDEBUG=1
 endif
endif

ifeq ($(shell echo $(RMDEBUG)),1)
 EXTRA_CFLAGS += -DDEBUG -g 
endif

ifneq ($(PATCHLEVEL), 4)
 COMPILE_TESTS = \
	remap_page_range \
	remap_pfn_range \
	vmap \
	signal_struct \
	agp_backend_acquire \
	set_pages_uc \
	change_page_attr \
	i2c_adapter \
	pci_get_class \
	pm_message_t \
	irq_handler_t \
	pci_choose_state \
	vm_insert_page \
	acpi_device_ops \
	acpi_device_id \
	acquire_console_sem \
	kmem_cache_create \
	on_each_cpu \
	smp_call_function \
	acpi_evaluate_integer \
	ioremap_wc \
	proc_dir_entry \
	acpi_walk_namespace \
	agp_memory \
	scatterlist \
	file_operations
else
 COMPILE_TESTS = \
	remap_page_range \
	vmap \
	change_page_attr \
	i2c_adapter \
	smp_call_function \
	acpi_evaluate_integer \
	proc_dir_entry \
	scatterlist
endif

#
# Miscellaneous NVIDIA kernel module build support targets. They are needed
# to satisfy KBUILD requirements and to support NVIDIA specifics.
#

$(obj)/$(CORE_OBJS):
	cp $(src)/$(CORE_OBJS) $(obj)/$(CORE_OBJS)

$(obj)/$(VERSION_HEADER):
	@ echo \#define NV_COMPILER \"`$(CC) -v 2>&1 | tail -n 1`\" > $@

$(obj)/conftest.h:
	@if ! $(CONFTEST) compile_tests $(COMPILE_TESTS); then exit 1; fi

$(obj)/patches.h:
	@if ! $(CONFTEST) patch_check; then exit 1; fi

RESMAN_GLUE_TARGETS = $(addprefix $(obj)/,$(RESMAN_GLUE_OBJS))

$(RESMAN_GLUE_TARGETS): $(obj)/conftest.h $(obj)/patches.h

$(obj)/nv.o: $(obj)/$(VERSION_HEADER)

#
# More quirks for Linux 2.4 KBUILD, which doesn't link automatically.
#

ifeq ($(PATCHLEVEL), 4)
$(obj)/$(MODULE_NAME).o: $($(MODULE_NAME)-objs)
	$(LD) $(EXTRA_LDFLAGS) -r -o $@ $($(MODULE_NAME)-objs)
endif

#
# KBUILD build parameters.
#

ifneq ($(strip $(QUIET)),1)
KBUILD_PARAMS += KBUILD_VERBOSE=1
endif
KBUILD_PARAMS += -C $(KERNEL_SOURCES) SUBDIRS=$(PWD)

#
# NVIDIA sanity checks.
#

.PHONY: suser-sanity-check rmmod-sanity-check build-sanity-checks

suser-sanity-check:
	@if ! $(CONFTEST) suser_sanity_check; then exit 1; fi

rmmod-sanity-check:
	@if ! $(CONFTEST) rmmod_sanity_check; then exit 1; fi

build-sanity-checks:
	@if ! $(CONFTEST) cc_version_check 		full_output; then exit 1; fi
	@if ! $(CONFTEST) rivafb_sanity_check 	full_output; then exit 1; fi
	@if ! $(CONFTEST) nvidiafb_sanity_check full_output; then exit 1; fi
	@if ! $(CONFTEST) xen_sanity_check 		full_output; then exit 1; fi

#
# Build the NVIDIA kernel module using Linux KBUILD. This target is used by
# the "package-install" target below.
#

module: build-sanity-checks
	@if [ -z "$(PATCHLEVEL)" ]; then \
	 echo "failed to determine PATCHLEVEL!"; \
	 exit 1; \
	fi; \
	echo "NVIDIA: calling KBUILD..."; \
	echo "make CC=$(CC) $(KBUILD_PARAMS) modules"; \
	make "CC=$(CC)" $(KBUILD_PARAMS) modules; \
	echo "NVIDIA: left KBUILD."; \
	if ! [ -f $(MODULE_OBJECT) ]; then \
	 echo "$(MODULE_OBJECT) failed to build!"; \
	 exit 1; \
	fi

#
# Build the NVIDIA kernel module with KBUILD. Verify that the user posesses
# sufficient privileges. Rebuild the module dependency file.
#

module-install: suser-sanity-check module
	@mkdir -p $(MODULE_ROOT)/video; \
	install -m 0664 -o root -g root $(MODULE_OBJECT) $(MODULE_ROOT)/video; \
	PATH="$(PATH):/bin:/sbin" depmod -ae;

#
# This target builds, then installs, then creates device nodes and inserts
# the module, if successful.
#

package-install: module-install rmmod-sanity-check
	PATH="$(PATH):/bin:/sbin" modprobe $(MODULE_NAME) && \
	echo "$(MODULE_OBJECT) installed successfully.";

#
# Build an object file suitable for further processing by the installer and
# inclusion as a precompiled kernel interface file.
#

$(KERNEL_GLUE_NAME): module
	$(LD) $(EXTRA_LDFLAGS) -r -o $(KERNEL_GLUE_NAME) $(KERNEL_GLUE_OBJS)

#
# Support hack, KBUILD isn't prepared to clean up after external modules.
#

clean:
	@ $(RM) -f $(RESMAN_GLUE_OBJS) $(KERNEL_GLUE_OBJS)
	@ $(RM) -f build-in.o nv-linux.o *.d .*.{cmd,flags}
	@ $(RM) -f $(MODULE_NAME).{o,ko,mod.{o,c}} $(VERSION_HEADER) *~
	@ $(RM) -f patches.h
	@ $(RM) -f conftest*.c conftest.h
	@ $(RM) -rf Modules.symvers .tmp_versions

#
# This target just prints the kernel module filename (for use by the
# installer)
#

print-module-filename:
	@ echo $(MODULE_OBJECT)

#
# Linux 2.4 KBUILD requires the inclusion of Rules.make; Linux 2.6's KBUILD
# includes dependencies automatically.
#

ifeq ($(PATCHLEVEL), 4)
include $(KERNEL_SOURCES)/Rules.make
endif

=== src/nvidia-legacy-96-96.43.19/Makefile ===
# This Makefile is automatically generated; do not edit
# Generated on 'builder75' on Wed Oct 27 19:01:35 PDT 2010

# to use this file, rename or delete the default Makefile, then rename or
# link this file to Makefile. then type 'make'

#
# KBUILD Makefile for the NVIDIA Linux kernel module.
#
# The motivation for replacing the original Makefile is the hope that this
# version will simplify the build and installation process. In the past,
# many architectural and cosmetic changes to the Linux kernel have made it
# difficult to maintain compatibility or required duplication of logic.
#
# Linux 2.6 introduces numerous such changes, many of which impact modules.
# Relying on KBUILD, some aspects of the build system otherwise difficult
# to support (for example, module versioning) are abstracted away and dealt
# with elsewhere, making life significantly easier here.
#
# The new approach currently has its own share of problems, some of which
# are architectural difficulties with KBUILD, others minor annoyances. For
# this reason, an improved version of the NVIDIA Makefile is available to
# those experiencing difficulties.
#
# kbuild Makefile originally developed by:
#
# Alistair J Strachan (alistair@devzero.co.uk) (first pass, enhancements)
# Christian Zander (zander@mail.minion.de) (enhancements)
#

all: install
install: package-install

#
# The NVIDIA kernel module base name and static file names. KBUILD will go
# ahead and append ".o" or ".ko" to form the final module name.
#

MODULE_NAME := nvidia
VERSION_HEADER := nv_compiler.h

#
# List of object files to link into NVIDIA kernel module; make sure KBUILD
# understands that we want a module.
#

CORE_OBJS := nv-kernel.o
RESMAN_GLUE_OBJS := nv.o nv-vm.o os-agp.o os-interface.o os-registry.o nv-i2c.o

$(MODULE_NAME)-objs := $(CORE_OBJS) $(RESMAN_GLUE_OBJS)

#
# The precompiled kernel module build process requires a separation of the
# closed source and open source object files.
#

KERNEL_GLUE_NAME := nv-linux.o
KERNEL_GLUE_OBJS := $(RESMAN_GLUE_OBJS) $(MODULE_NAME).mod.o

#
# A bug in KBUILD 2.4 means that leaving obj-m set in top-level context
# will cause Rules.make to call pathdown.sh, which is wrong. So, we only
# set this conditional of a kernel-level instance.
#

TOPDIR ?= $(srctree)

ifdef TOPDIR
obj-m := $(MODULE_NAME).o
endif

#
# Include local source directory in $(CC)'s include path and set disable any
# warning types that are of little interest to us.
#

EXTRA_CFLAGS += -I$(src)
EXTRA_CFLAGS += -Wall -Wimplicit -Wreturn-type -Wswitch -Wformat -Wchar-subscripts -Wparentheses -Wpointer-arith -Wno-multichar -Werror -MD $(DEFINES) $(INCLUDES) -Wsign-compare -Wno-cast-qual -Wno-error

#
# We rely on these two definitions below; if they aren't set, we set them to
# reasonable defaults (Linux 2.4's KBUILD, and top-level passes will not set
# these).
#

src ?= .
obj ?= .

#
# Determine location of the Linux kernel source tree. Allow users to override
# the default (i.e. automatically determined) kernel source location with the
# SYSSRC directive; this new directive replaces NVIDIA's SYSINCLUDE.
#

KERNEL_MODLIB := /lib/modules/$(shell uname -r)

ifdef SYSSRC
 KERNEL_SOURCES := $(SYSSRC)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
else
 KERNEL_UNAME := $(shell uname -r)
 KERNEL_SOURCES := $(shell test -d $(KERNEL_MODLIB)/source && echo $(KERNEL_MODLIB)/source || echo $(KERNEL_MODLIB)/build)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
endif

KERNEL_OUTPUT := $(KERNEL_SOURCES)
KBUILD_PARAMS :=

ifdef SYSOUT
 ifneq ($(SYSOUT), $(KERNEL_SOURCES))
 KERNEL_OUTPUT := $(SYSOUT)
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
else
 ifeq ($(KERNEL_SOURCES), $(KERNEL_MODLIB)/source)
 KERNEL_OUTPUT := $(KERNEL_MODLIB)/build
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
endif

CC ?= cc
HOST_CC ?= $(CC)
OBJDUMP ?= objdump
CONFTEST := /bin/sh $(src)/conftest.sh "$(CC)" "$(HOST_CC)" $(KERNEL_SOURCES) $(KERNEL_OUTPUT)

KERNEL_UNAME ?= $(shell $(CONFTEST) get_uname)
MODULE_ROOT := /lib/modules/$(KERNEL_UNAME)/kernel/drivers

#
# Sets any internal variables left unset by KBUILD (e.g. this happens during
# a top-level run).
#

TOPDIR ?= $(KERNEL_SOURCES)
PATCHLEVEL ?= $(shell $(CONFTEST) kernel_patch_level)

#
# Linux 2.4 uses the .o module extension. Linux 2.6, however, uses the .ko
# module extension. Handle these gracefully.
#

ifeq ($(PATCHLEVEL), 4)
 MODULE_OBJECT := $(MODULE_NAME).o
else
 MODULE_OBJECT := $(MODULE_NAME).ko
endif

#
# NVIDIA specific CFLAGS and #define's. The remap_page_range check has become
# necessary with the introduction of the five argument version to Linux 2.4
# distribution kernels; this conflicting change cannot be detected at compile
# time.
#

EXTRA_CFLAGS += -D_LOOSE_KERNEL_NAMES -D__KERNEL__ -DMODULE -DNVRM -DNV_VERSION_STRING=\"96.43.19\" -UDEBUG -U_DEBUG -DNDEBUG

ifeq ($(shell echo $(NVDEBUG)),1)
 ifeq ($(shell test -z $(RMDEBUG) && echo yes),yes)
 RMDEBUG=1
 endif
endif

ifeq ($(shell echo $(RMDEBUG)),1)
 EXTRA_CFLAGS += -DDEBUG -g 
endif

ifneq ($(PATCHLEVEL), 4)
 COMPILE_TESTS = \
	remap_page_range \
	remap_pfn_range \
	vmap \
	agp_backend_acquire \
	set_pages_uc \
	change_page_attr \
	i2c_adapter \
	pci_get_class \
	pm_message_t \
	irq_handler_t \
	pci_choose_state \
	vm_insert_page \
	acquire_console_sem \
	kmem_cache_create \
	on_each_cpu \
	smp_call_function \
	ioremap_wc \
	proc_dir_entry \
	acpi_walk_namespace \
	agp_memory \
	scatterlist \
	file_operations \
	sg_init_table
else
 COMPILE_TESTS = \
	remap_page_range \
	vmap \
	change_page_attr \
	i2c_adapter \
	smp_call_function \
	proc_dir_entry \
	scatterlist
endif

#
# Miscellaneous NVIDIA kernel module build support targets. They are needed
# to satisfy KBUILD requirements and to support NVIDIA specifics.
#

$(obj)/$(CORE_OBJS):
	cp $(src)/$(CORE_OBJS) $(obj)/$(CORE_OBJS)

$(obj)/$(VERSION_HEADER):
	@ echo \#define NV_COMPILER \"`$(CC) -v 2>&1 | tail -n 1`\" > $@

$(obj)/conftest.h:
	@if ! $(CONFTEST) compile_tests $(COMPILE_TESTS); then exit 1; fi

$(obj)/patches.h:
	@if ! $(CONFTEST) patch_check; then exit 1; fi

RESMAN_GLUE_TARGETS = $(addprefix $(obj)/,$(RESMAN_GLUE_OBJS))

$(RESMAN_GLUE_TARGETS): $(obj)/conftest.h $(obj)/patches.h

$(obj)/nv.o: $(obj)/$(VERSION_HEADER)

#
# More quirks for Linux 2.4 KBUILD, which doesn't link automatically.
#

ifeq ($(PATCHLEVEL), 4)
$(obj)/$(MODULE_NAME).o: $($(MODULE_NAME)-objs)
	$(LD) $(EXTRA_LDFLAGS) -r -o $@ $($(MODULE_NAME)-objs)
endif

#
# KBUILD build parameters.
#

KBUILD_PARAMS += KBUILD_VERBOSE=1 -C $(KERNEL_SOURCES) SUBDIRS=$(PWD)

#
# NVIDIA sanity checks.
#

.PHONY: suser-sanity-check rmmod-sanity-check build-sanity-checks

suser-sanity-check:
	@if ! $(CONFTEST) suser_sanity_check; then exit 1; fi

rmmod-sanity-check:
	@if ! $(CONFTEST) rmmod_sanity_check; then exit 1; fi

build-sanity-checks:
	@if ! $(CONFTEST) cc_version_check 		full_output; then exit 1; fi
	@if ! $(CONFTEST) rivafb_sanity_check 	full_output; then exit 1; fi
	@if ! $(CONFTEST) nvidiafb_sanity_check full_output; then exit 1; fi
	@if ! $(CONFTEST) xen_sanity_check 		full_output; then exit 1; fi

#
# Build the NVIDIA kernel module using Linux KBUILD. This target is used by
# the "package-install" target below.
#

module: build-sanity-checks
	@if [ -z "$(PATCHLEVEL)" ]; then \
	 echo "failed to determine PATCHLEVEL!"; \
	 exit 1; \
	fi; \
	echo "NVIDIA: calling KBUILD..."; \
	echo "make CC=$(CC) $(KBUILD_PARAMS) modules"; \
	make "CC=$(CC)" $(KBUILD_PARAMS) modules; \
	echo "NVIDIA: left KBUILD."; \
	if ! [ -f $(MODULE_OBJECT) ]; then \
	 echo "$(MODULE_OBJECT) failed to build!"; \
	 exit 1; \
	fi

#
# Build the NVIDIA kernel module with KBUILD. Verify that the user posesses
# sufficient privileges. Rebuild the module dependency file.
#

module-install: suser-sanity-check module
	@mkdir -p $(MODULE_ROOT)/video; \
	install -m 0664 -o root -g root $(MODULE_OBJECT) $(MODULE_ROOT)/video; \
	PATH="$(PATH):/bin:/sbin" depmod -ae;

#
# This target builds, then installs, then creates device nodes and inserts
# the module, if successful.
#

package-install: module-install rmmod-sanity-check
	PATH="$(PATH):/bin:/sbin" modprobe $(MODULE_NAME) && \
	echo "$(MODULE_OBJECT) installed successfully.";

#
# Build an object file suitable for further processing by the installer and
# inclusion as a precompiled kernel interface file.
#

$(KERNEL_GLUE_NAME): module
	$(LD) $(EXTRA_LDFLAGS) -r -o $(KERNEL_GLUE_NAME) $(KERNEL_GLUE_OBJS)

#
# Support hack, KBUILD isn't prepared to clean up after external modules.
#

clean:
	@ $(RM) -f $(RESMAN_GLUE_OBJS) $(KERNEL_GLUE_OBJS)
	@ $(RM) -f build-in.o nv-linux.o *.d .*.{cmd,flags}
	@ $(RM) -f $(MODULE_NAME).{o,ko,mod.{o,c}} $(VERSION_HEADER) *~
	@ $(RM) -f patches.h
	@ $(RM) -f conftest*.c conftest.h
	@ $(RM) -rf Modules.symvers .tmp_versions

#
# This target just prints the kernel module filename (for use by the
# installer)
#

print-module-filename:
	@ echo $(MODULE_OBJECT)

#
# Linux 2.4 KBUILD requires the inclusion of Rules.make; Linux 2.6's KBUILD
# includes dependencies automatically.
#

ifeq ($(PATCHLEVEL), 4)
include $(KERNEL_SOURCES)/Rules.make
endif

=== src/virtualbox-ose-guest-3.1.6/Makefile ===
.NOTPARALLEL:

obj-m = vboxguest/ vboxvfs/ vboxvideo/

=== src/virtualbox-ose-guest-3.1.6/vboxvfs/Makefile ===
#
# VirtualBox Guest Additions Module Makefile.
#
# (For 2.6.x this file must be 'Makefile'!)
#
# Copyright (C) 2006-2007 Sun Microsystems, Inc.
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 USA or visit http://www.sun.com if you need
# additional information or have any questions.
#

#
# First, figure out which architecture we're targeting and the build type.
# (We have to support basic cross building (ARCH=i386|x86_64).)
# While at it, warn about BUILD_* vars found to help with user problems.
#
ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
 BUILD_TARGET_ARCH_DEF := amd64
else
 BUILD_TARGET_ARCH_DEF := x86
endif
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   ifeq ($(CONFIG_X86_32),y)
     BUILD_TARGET_ARCH := x86
   else
     BUILD_TARGET_ARCH := amd64
   endif
  else
    ifeq ($(ARCH),x86)
      ifeq ($(CONFIG_X86_32),y)
        BUILD_TARGET_ARCH := x86
      else
        BUILD_TARGET_ARCH := amd64
      endif
    else
      BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
    endif
  endif
 endif
else
 ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
 endif
endif

ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
 $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
 BUILD_TYPE :=
endif
ifeq ($(BUILD_TYPE),)
 BUILD_TYPE := release
else
 ifneq ($(BUILD_TYPE),release)
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
endif


# override is required by the Debian guys
override MODULE = vboxvfs
OBJS   = \
	vfsmod.o \
	dirops.o \
	regops.o \
	utils.o \
	GenericRequest.o \
	SysHlp.o \
	PhysHeap.o \
	Init.o \
	VMMDev.o \
	HGCM.o \
	VBoxCalls.o \
	VbglR0CanUsePhysPageList.o
ifeq ($(BUILD_TARGET_ARCH),x86)
OBJS  += \
	divdi3.o \
	moddi3.o \
	udivdi3.o \
	umoddi3.o \
	qdivrem.o
endif

EXTRA_CFLAGS = -fshort-wchar

ifneq ($(MAKECMDGOALS),clean)

ifeq ($(KERNELRELEASE),)

 #
 # building from this directory
 #

 # kernel base directory
 ifndef KERN_DIR
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   KERN_DIR := /usr/src/linux
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
    $(error Error: unable to find the sources of your current Linux kernel. \
	           Specify KERN_DIR=<directory> and run Make again)
   endif
   $(warning Warning: using /usr/src/linux as the source directory of your \
                      Linux kernel. If this is not correct, specify \
		      KERN_DIR=<directory> and run Make again.)
  endif
 else
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: KERN_DIR does not point to a directory)
  endif
 endif

 # includes
 ifndef KERN_INCL
  KERN_INCL = $(KERN_DIR)/include
 endif
 ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
  $(error Error: unable to find the include directory for your current Linux \
                 kernel. Specify KERN_INCL=<directory> and run Make again)
 endif

 # module install dir.
 ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
  ifndef MODULE_DIR
   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
    MODULE_DIR := $(MODULE_DIR_TST)/misc
   else
    $(error Unable to find the folder to install the shared folders driver to)
   endif
  endif # MODULE_DIR unspecified
 endif

 # guess kernel version (24 or 26)
 ifeq ($(shell if grep '"2\.4\.' $(KERN_INCL)/linux/version.h > /dev/null; then echo yes; fi),yes)
  KERN_VERSION := 24
 else
  KERN_VERSION := 26
 endif

else # neq($(KERNELRELEASE),)

 #
 # building from kbuild (make -C <kernel_directory> M=`pwd`)
 #

 # guess kernel version (24 or 26)
 ifeq ($(shell if echo "$(VERSION).$(PATCHLEVEL)." | grep '2\.4\.' > /dev/null; then echo yes; fi),yes)
  KERN_VERSION := 24
 else
  KERN_VERSION := 26
 endif

endif # neq($(KERNELRELEASE),)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
$(warning dbg: KERN_VERSION = $(KERN_VERSION))
endif

KBUILD_VERBOSE ?= 1

#
# Compiler options
#
ifndef INCL
 INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 export INCL
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 \
	    -DIN_SUP_R0 -DVBOX -DVBOX_WITH_HGCM -DIN_MODULE -DIN_GUEST_R0
# our module does not export any symbol
KFLAGS   += -DRT_NO_EXPORT_SYMBOL
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64 -DVBOX_WITH_64_BITS_GUESTS
else
 KFLAGS  += -DRT_ARCH_X86
endif
ifeq ($(BUILD_TYPE),debug)
 KFLAGS  += -DDEBUG
endif

ifeq ($(KERN_VERSION), 24)
#
# 2.4
#

ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -mcmodel=kernel
endif

CFLAGS := -O2 -DVBOX_LINUX_2_4 $(INCL) $(KFLAGS) $(KDEBUG)
MODULE_EXT := o

# 2.4 Module linking
$(MODULE).o: $(OBJS)
	$(LD) -o $@ -r $(OBJS)

.PHONY: $(MODULE)
all: $(MODULE)
$(MODULE): $(MODULE).o

else
#
# 2.6 and later
#

MODULE_EXT := ko

$(MODULE)-y  := $(OBJS)

# special hack for Fedora Core 6 2.6.18 (fc6), rhel5 2.6.18 (el5),
# ClarkConnect 4.3 (cc4) and ClarkConnect 5 (v5)
ifeq ($(KERNELRELEASE),)
 KFLAGS += $(foreach inc,$(KERN_INCL),\
             $(if $(wildcard $(inc)/linux/utsrelease.h),\
               $(if $(shell grep '"2.6.18.*fc6.*"' $(inc)/linux/utsrelease.h; \
			    grep '"2.6.18.*el5.*"' $(inc)/linux/utsrelease.h; \
			    grep '"2.6.18.*v5.*"'  $(inc)/linux/utsrelease.h; \
			    grep '"2.6.18.*cc4.*"' $(inc)/linux/utsrelease.h),\
		-DKERNEL_FC6,),))
else
 KFLAGS += $(if $(shell echo "$(KERNELRELEASE)"|grep '2.6.18.*fc6.*';\
			echo "$(KERNELRELEASE)"|grep '2.6.18.*el5.*';\
			echo "$(KERNELRELEASE)"|grep '2.6.18.*v5.*';\
			echo "$(KERNELRELEASE)"|grep '2.6.18.*cc4.*'),\
		-DKERNEL_FC6,)
endif

# build defs
EXTRA_CFLAGS += $(INCL) $(KFLAGS) $(KDEBUG)

all: $(MODULE)

obj-m += $(MODULE).o

$(MODULE):
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules

endif

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -a;

endif # eq($(MAKECMDGOALS),clean)

# important: Don't remove Module.symvers! DKMS does 'make clean' before building ...
clean:
	for f in . linux r0drv r0drv/linux; do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
	rm -rf .vboxvfs* .tmp_ver* vboxvfs.* Modules.symvers modules.order

=== src/virtualbox-ose-guest-3.1.6/vboxvideo/Makefile ===
#
# VirtualBox Guest Additions Module Makefile.
#
# (For 2.6.x this file must be 'Makefile'!)
#
# Copyright (C) 2006-2007 Sun Microsystems, Inc.
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 USA or visit http://www.sun.com if you need
# additional information or have any questions.
#

## @todo We must make this into a common template *soon*.

#
# First, figure out which architecture we're targeting and the build type.
# (We have to support basic cross building (ARCH=i386|x86_64).)
# While at it, warn about BUILD_* vars found to help with user problems.
#
ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
 BUILD_TARGET_ARCH_DEF := amd64
else
 BUILD_TARGET_ARCH_DEF := x86
endif
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   BUILD_TARGET_ARCH := x86
  else
   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
  endif
 endif
else
 ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
 endif
endif

ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
 $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
 BUILD_TYPE :=
endif
ifeq ($(BUILD_TYPE),)
 BUILD_TYPE := release
else
 ifneq ($(BUILD_TYPE),release)
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
endif

EXTRA_CFLAGS = -fshort-wchar

ifneq ($(MAKECMDGOALS),clean)

ifeq ($(KERNELRELEASE),)

 #
 # building from this directory
 #

 # kernel base directory
 ifndef KERN_DIR
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   KERN_DIR := /usr/src/linux
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
    $(error Error: unable to find the sources of your current Linux kernel. \
	           Specify KERN_DIR=<directory> and run Make again)
   endif
   $(warning Warning: using /usr/src/linux as the source directory of your \
                      Linux kernel. If this is not correct, specify \
		      KERN_DIR=<directory> and run Make again.)
  endif
 else
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: KERN_DIR does not point to a directory)
  endif
 endif

 # includes
 ifndef KERN_INCL
  KERN_INCL = $(KERN_DIR)/include
 endif
 ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
  $(error Error: unable to find the include directory for your current Linux \
                 kernel. Specify KERN_INCL=<directory> and run Make again)
 endif

 # module install dir.
 ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
  ifndef MODULE_DIR
   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
    MODULE_DIR := $(MODULE_DIR_TST)/misc
   else
    $(error Unable to find the folder to install the DRM driver to)
   endif
  endif # MODULE_DIR unspecified
 endif

 # guess kernel version (24 or 26)
 ifeq ($(shell if grep '"2\.4\.' $(KERN_INCL)/linux/version.h > /dev/null; then echo yes; fi),yes)
  KERN_VERSION := 24
 else
  KERN_VERSION := 26
 endif

else # neq($(KERNELRELEASE),)

 #
 # building from kbuild (make -C <kernel_directory> M=`pwd`)
 #

 # guess kernel version (24 or 26)
 ifeq ($(shell if echo "$(VERSION).$(PATCHLEVEL)." | grep '2\.4\.' > /dev/null; then echo yes; fi),yes)
  KERN_VERSION := 24
 else
  KERN_VERSION := 26
 endif

endif # neq($(KERNELRELEASE),)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
$(warning dbg: KERN_VERSION = $(KERN_VERSION))
endif

KBUILD_VERBOSE ?= 1

#
# Compiler options
#
ifndef INCL
 INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 export INCL
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 \
	    -DIN_SUP_R0 -DVBOX -DVBOX_WITH_HGCM -DLOG_TO_BACKDOOR -DIN_MODULE \
	    -DIN_GUEST_R0
# our module does not export any symbol
KFLAGS   += -DRT_NO_EXPORT_SYMBOL
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64 -DVBOX_WITH_64_BITS_GUESTS
else
 KFLAGS  += -DRT_ARCH_X86
endif
ifeq ($(BUILD_TYPE),debug)
KFLAGS   += -DDEBUG
endif

# override is required by the Debian guys
override MODULE = vboxvideo
OBJS   = vboxvideo_drm.o

ifeq ($(KERN_VERSION), 24)
#
# 2.4
#

CFLAGS := -O2 -DVBOX_LINUX_2_4 $(INCL) $(KFLAGS) $(KDEBUG)
MODULE_EXT := o

# 2.4 Module linking
$(MODULE).o: $(OBJS)
	$(LD) -o $@ -r $(OBJS)

.PHONY: $(MODULE)
all: $(MODULE)
$(MODULE): $(MODULE).o

else
#
# 2.6 and later
#

MODULE_EXT := ko

$(MODULE)-y  := $(OBJS)

# special hack for Fedora Core 6 2.6.18 (fc6), rhel5 2.6.18 (el5),
# ClarkConnect 4.3 (cc4) and ClarkConnect 5 (v5)
ifeq ($(KERNELRELEASE),)
 KFLAGS += $(foreach inc,$(KERN_INCL),\
             $(if $(wildcard $(inc)/linux/utsrelease.h),\
               $(if $(shell grep '"2.6.18.*fc6.*"' $(inc)/linux/utsrelease.h; \
			    grep '"2.6.18.*el5.*"' $(inc)/linux/utsrelease.h; \
			    grep '"2.6.18.*v5.*"'  $(inc)/linux/utsrelease.h; \
			    grep '"2.6.18.*cc4.*"' $(inc)/linux/utsrelease.h),\
		-DKERNEL_FC6,),))
else
 KFLAGS += $(if $(shell echo "$(KERNELRELEASE)"|grep '2.6.18.*fc6.*';\
			echo "$(KERNELRELEASE)"|grep '2.6.18.*el5.*';\
			echo "$(KERNELRELEASE)"|grep '2.6.18.*v5.*';\
			echo "$(KERNELRELEASE)"|grep '2.6.18.*cc4.*'),\
		-DKERNEL_FC6,)
endif

# build defs
EXTRA_CFLAGS += $(INCL) $(KFLAGS) $(KDEBUG)

all: $(MODULE)

obj-m += $(MODULE).o

$(MODULE):
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules

endif

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -a;

endif # eq($(MAKECMDGOALS),clean)

# important: Don't remove Module.symvers! DKMS does 'make clean' before building ...
clean:
	for f in . linux r0drv r0drv/linux; do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
	rm -rf .vboxvideo* .tmp_ver* vboxvideo.* Modules.symvers modules.order

=== debian/changelog ===
jolicloud-hardware-repo (1.2.6) robby-1.2; urgency=low

  * Upgraded poulsbo-config to 0.1.2~1010um14jolicloud3
    - Do not prompt reboot notification, or other invasive procedures,
      when installing under casper. These procedures will proceed when
      installed directly under HDD at the following reboot.

 -- Adam McDaniel <adam@jolicloud.org>  Mon, 14 Feb 2011 07:36:51 -0700

jolicloud-hardware-repo (1.2.5) robby-1.2; urgency=low

  * Upgraded poulsbo-config to 0.1.2~1010um14jolicloud2
    - If X isn't running at install time, default to a safe uvesafb resolution
    - Remove GMA500 vaapi workaround from /etc/rc.local, instead install
      in /etc/profile.d
    - Notify the user that reboot is required after postinst

 -- Adam McDaniel <adam@jolicloud.org>  Sun, 13 Feb 2011 20:38:40 -0700

jolicloud-hardware-repo (1.2.4) robby-1.2; urgency=low

  * Downgraded libva1 from 1.0.1-3+0.31.1-1+sds4 to 0.31.0-2jolicloud1+sds9
    - The 1.0.1 version was built against maverick libraries which is not
      compatibile with robby-1.1.1 runtime environment.

 -- Adam McDaniel <adam@jolicloud.org>  Thu, 10 Feb 2011 12:20:05 -0700

jolicloud-hardware-repo (1.2.3) robby-1.2; urgency=low

  * Upgraded nvidia-current to 260.19.29-1jolicloud4
    - Revert "Nvidia recommends linking with OSS libvdpau, not their
      version as it will soon be depricated"
    - Make nvidia-current depend on libvdpau.so wrapper, as required by
      libvdpau_nvidia.so

 -- Adam McDaniel <adam@jolicloud.org>  Wed, 09 Feb 2011 21:13:34 -0700

jolicloud-hardware-repo (1.2.2) robby-1.2; urgency=low

  * Upgraded psb with latest gma500-maverick mirror of Poulsbo support
  * Upgraded jolicloud-poulsbo to 1.2.0
    - Removed jolicloud-poulsbo's poulsbo.conf, now provided by upstream
    - Remove the funky tweaks that jolicloud-poulsbo established, instead
      allow upstream poulsbo-config to create them.
  * Upgrade poulsbo-config to 0.1.2~1010um14jolicloud1
    - Postinst's call to update-grub2 will fail when installing poulsbo-config
      within casper's environment. Ignore update-grub2's return value and allow
      the postinst to complete.
  * Downgrade xserver-xorg-video-psb to 0.36.0-0ubuntu3~1004un1.1
    - Proper support X 1.7.6.901

 -- Adam McDaniel <adam@jolicloud.org>  Mon, 07 Feb 2011 19:50:45 +0100

jolicloud-hardware-repo (1.2.1) robby-1.2; urgency=low

  * Renamed nvidia/ to nvidia-current/; added nvidia-legacy-173,96
    packages

 -- Adam McDaniel <adam@jolicloud.org>  Fri, 04 Feb 2011 15:01:03 +0100

jolicloud-hardware-repo (1.2.0) robby-1.2; urgency=low

  * Upgraded nvidia-current to 260.19.29-1jolicloud3
    - Recreated the manually generated modaliases file to identify exactly
      which chipsets are supported by this driver in jockey.
    - Resumed DKMS build of NVIDIA kernel module.
    - Upgraded to upstream NVIDIA Linux driver 260.19.29

 -- Adam McDaniel <adam@jolicloud.org>  Tue, 25 Jan 2011 10:31:29 -0700

jolicloud-hardware-repo (1.1.4~2) robby-lucid; urgency=low

  * Updated psb/uswsusp to 0.8-1.3jolicloud2+2m1
    - Silently bypass the system-check for swap-space... can fail if
      uswsusp is installed prior to swap-space coming online.

 -- Adam McDaniel <adam@jolicloud.org>  Fri, 03 Dec 2010 03:03:32 -0700

jolicloud-hardware-repo (1.1.4~1) robby-lucid; urgency=low

  * Upgraded uswsusp to 0.8-1.3jolicloud1+2m2:
    - Lower the priority of debconf critical inputs which detect no swap
      or snapshot available, as is the case when booting under isolinux.

 -- Adam McDaniel <adam@jolicloud.org>  Wed, 01 Dec 2010 17:11:31 +0100

jolicloud-hardware-repo (1.1.3) robby-lucid; urgency=low

  * Added uswsusp (0.8-1.1ubuntu3) into psb repository as
    jolicloud-poulsbo now depends on it

 -- Adam McDaniel <adam@jolicloud.org>  Mon, 29 Nov 2010 21:13:21 +0100

jolicloud-hardware-repo (1.1.2) robby-lucid; urgency=low

  * Added missing virtualbox-ose-guest-dkms (3.1.6-dfsg-2ubuntu2) to
    vboxguest
  * Upgraded virtualbox-ose-guest-dkms to 3.2.8-dfsg-2ubuntu1; removed
    depricated virtualbox-ose-dkms
  * Updated package description, now classified as restricted
  * Downgraded virtualbox-ose-guest-dkms to 3.1.6-dfsg-3jolicloud1 
    (Stay in-line with other vboxguest packages)
  * Upgraded jolicloud-poulsbo to 1.1.1

 -- Adam McDaniel <adam@jolicloud.org>  Fri, 26 Nov 2010 17:10:28 +0100

jolicloud-hardware-repo (1.1.1) robby-lucid; urgency=low 

  [Adam McDaniel]
  * Upgraded nvidia-current to 260.19.12-1jolicloud2

  [Andrew Stormont]
  * Use patched virtualbox-ose packages for vbox instead.
  * Add VboxGuestAdditions installer

 -- Adam McDaniel <adam@jolicloud.org>  Wed, 10 Nov 2010 16:16:57 +0100

jolicloud-hardware-repo (1.1.0) robby-lucid; urgency=low

  * Upgraded nvidia-current to 260.19.12-1jolicloud1

 -- Adam McDaniel <adam@jolicloud.org>  Mon, 01 Nov 2010 18:59:53 -0600

jolicloud-hardware-repo (1.1.0~3) robby-lucid; urgency=low

  * Set source format to "3.0 (native)"
  * Removed psb-kernel-source: driver now provided by the kernel, and
    other redundant meta-packages
  * Added autotools-dev, libtool to satisfy xserver-xorg-video-psb
    dependency
  * Upgraded jolicloud-poulsbo to 1.1.0~2.git.20101018t212808.b9e9e7e

 -- Adam McDaniel <adam@jolicloud.org>  Mon, 18 Oct 2010 15:30:06 -0600

jolicloud-hardware-repo (1.1.0~2) robby-lucid; urgency=low

  * Removed depricated nvidia packages
  * Upgraded nvidia packages to 195.36.24-1jolicloud1+l0u1~10.04

 -- Adam McDaniel <adam@jolicloud.org>  Sat, 09 Oct 2010 19:22:10 -0600

jolicloud-hardware-repo (1.1.0~1.git.20100907t003038.2dac2c7) robby-lucid; urgency=low

  ** SNAPSHOT build @2dac2c71622a610ac142509cc158a5ab22e2dfb9 **

  * Upgraded NVidia packages to 195.36.24-0ubuntu1~10.04 (lucid build)
  * Updated poulsbo packages from Lucid PPA source
  * Bumped revision number to coincide with Jolicloud V1.1
  * Updated psb/jolicloud-pouslbo to reference upstream pouslbo-config
  * Set source format to "3.0 (git)"


=== debian/control ===
Source: jolicloud-hardware-repo
Section: restricted/misc
Priority: standard
Maintainer: Adam McDaniel <adam@jolicloud.org>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.7.2

Package: jolicloud-hardware-repo
Architecture: i386
Description: Jolicloud-hardware package repository
 The jolicloud-hardware-repo is a collection of DEB packages that are
 shipped in compiled form onto machines so that they are available on a
 machine when it first boots up. When jolicloud-hardware detects its
 running on hardware that requires special support, it automatically
 installs one or more packages from this repository prior to X starting up.
 .
 All packages within are not compatible with the general installation ISO
 or standard meta-packages, and as such cannot be installed en masse. For
 example, installing a gma500 libdrm ontoa non-gma500 device will produce
 nothing bit drm failures.
 .
 Current hardware supported by jolicloud-hardware-repo includes:
 - GMA500 (aka poulsbo) video cards
 - Nvidia (ION, GeForce, etc) video cards
 - Virtualbox-guest installations

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1


configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp  
	dh_testdir
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -rf build-stamp configure-stamp

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installinit -r --no-start
	dh_install
	dh_icons
	dh_link
	#dh_strip #This fails !?
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
